// 001 u_c_tlist_of_c_double
// 30 jun 2007

// -- (C) John COLIBRI 2007
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_tlist_of_c_double;
  interface
    Uses Classes;

    type c_double= Class
                     m_double: Double;
                     Constructor create(p_double: Double);
                   end; // c_double

         c_tlist_of_c_double= Class(tList)
                                 Private
                                   function get_double(p_index: Integer): Double;
                                   procedure set_double(p_index: Integer; p_double: Double);

                                 Public
                                   Constructor create;
                                   procedure add_double(p_double: Double);
                                   Destructor Destroy; Override;

                                   Property Doubles[p_index: Integer] : Double
                                       Read get_double Write set_double; Default;
                                 end; // c_tlist_of_c_double

  implementation
    Uses SysUtils, u_c_display;

    // -- c_double

    Constructor c_double.create(p_double: Double);
      begin
        display('    create_double '+ FloatToStr(p_double));
        Inherited Create;
        m_double:= p_double;
      end; // create

    // -- c_tlist_of_c_double.

    Constructor c_tlist_of_c_double.create;
      begin
        display('create_list');
        Inherited Create;
      end; // create

    procedure c_tlist_of_c_double.add_double(p_double: Double);
      begin
        display('add_double');
        Inherited Add(c_double.create(p_double))
      end; // add_double

    function c_tlist_of_c_double.get_double(p_index: Integer): Double;
      begin
        if p_index>= Count
          then Raise Exception.Create('p_index> m_count');

        Result:= c_double(Items[p_index]).m_double;
      end; // get_double

    procedure c_tlist_of_c_double.set_double(p_index: Integer; p_double: Double);
      var l_index: Integer;
      begin
        display('alloc');
        // -- if index beyond Count, create with 0 filled cells
        if p_index>= Count
          then
            For l_index:= Count to p_index do
            begin
              display('  alloc  '+ IntToStr(l_index));
              add_double(0);
            end;

        display('  assign '+ IntToStr(p_index));
        c_double(Items[p_index]).m_double:= p_double;
      end; // set_double

    Destructor c_tlist_of_c_double.destroy;
      var l_index: Integer;
      begin
        display('free');
        for l_index:= 0 To Count- 1 do
          c_double(Items[l_index]).Free;

        Inherited;
      end; // destroy


end.
